c-----------------------------------------------------------------------
c     sample2d.f : sample program of ELview-2d
c
c     usage :
c     > ifort sample2d.f ev_f.lib
c     > sample2d
c     > ev2
c-----------------------------------------------------------------------
      program sample2d
c
      integer i, j, n
      integer ndiv, nx, ny
      real    px(3), py(3)
      real    x1, y1, x2, y2
      real    fmin, fmax
      real    f(0:100), z(31*21)
      integer r(3), g(3), b(3)
      real    w, h
      character ch*20
      data w, h / 300.0, 200.0 /
c
c     === page 1 ===
c
      call startPage(w, h)
c
c     --- line ---
      call drawLine(10.0, 20.0, 140.0, 20.0)
      call setColorNo(20)
      call drawLine(10.0, 30.0, 140.0, 30.0)
c
c     --- characters ---
      call setColorNo(1)
      call drawString(10.0, 80.0, 10.0, 'sample-2d {')
      call setColorNo(0)
      call drawString(10.0, 60.0,  7.0, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')
      call drawString(10.0, 50.0,  7.0, 'abcdefghijklmnopqrstuvwxyz')
      call drawString(10.0, 40.0,  7.0, '0123456789')
c
c     --- flat shading ---
      px(1) =  10.0
      px(2) =  90.0
      px(3) =  50.0
      py(1) = 120.0
      py(2) = 120.0
      py(3) = 180.0
      call setColor(0, 255, 0)
      call fillPolygon(3, px, py)
c
c     --- smooth shading (vertex shading) ---
      px(1) = 110.0
      px(2) = 190.0
      px(3) = 150.0
      py(1) = 120.0
      py(2) = 120.0
      py(3) = 180.0
      r(1) = 255
      r(2) =   0
      r(3) =   0
      g(1) =   0
      g(2) = 255
      g(3) =   0
      b(1) =   0
      b(2) =   0
      b(3) = 255
      call gradPolygon(3, px, py, r, g, b)
c
c     --- wire ---
      px(1) = 210.0
      px(2) = 290.0
      px(3) = 250.0
      py(1) = 120.0
      py(2) = 120.0
      py(3) = 180.0
      call setColor(0, 0, 255)
      call drawPolygon(3, px, py)
c
c     --- ellipse ---
      call setColorNo(17)
      call drawEllipse(180.0, 10.0, 270.0, 100.0)
      call setColorNo(3)
      call fillEllipse(200.0, 20.0, 250.0,  90.0)
c
c     === page 2 ===
c
      call startPage(w, h)
c
c     --- y = f(x) ---
      x1 =  20.0
      y1 = 100.0
      x2 = 140.0
      y2 = 180.0
      call evGrid(x1, y1, x2, y2, 10, 6)
c
      ndiv = 100
      do n = 0, ndiv
        f(n) = 1.0 - (REAL(n)/REAL(ndiv))**2
      enddo
      fmin = 0.0
      fmax = 1.0
      call evFunc1(ndiv, f, fmin, fmax, x1, y1, x2, y2)
c
c     --- arrow ---
      call evArrow(x1+20.0, y1-10.0, x1+40.0, y1-10.0)
c
c     --- contour : z = f(x,y) ---
      nx = 30
      ny = 20
      fmin = 0.0
      fmax = (nx*nx + ny*ny)/4.0
      do i = 0, nx
        do j = 0, ny
          z(i*(ny+1)+j+1) = fmax - ((i-nx/2.0)**2 + (j-ny/2.0)**2)
        enddo
      enddo
      x1 = 170.0
      x2 = 290.0
      call evContour1(nx, ny, z, fmin, fmax, 0, x1,   5.0, x2,  45.0)
      call evContour1(nx, ny, z, fmin, fmax, 2, x1,  55.0, x2,  95.0)
      call evContour1(nx, ny, z, fmin, fmax, 4, x1, 105.0, x2, 145.0)
      call evContour1(nx, ny, z, fmin, fmax, 6, x1, 155.0, x2, 195.0)
c
c     --- color sample ---
      call evColors(10.0, 20.0, 160.0, 40.0, 1, 0)
      do n = 1, 20
        write(ch, '(i2)') n
        call drawString(2.0+7.5*n, 14.0, 5.0, ch)
      enddo
c
      stop
      end
